module Expr where

import Parse

data Expr = Con Int
          | Expr :+: Expr
          | Expr :*: Expr

instance Show Expr where
  show (Con i)    =  show i
  show (e :+: f)  =  "(" ++ show e ++ "+" ++ show f ++ ")"
  show (e :*: f)  =  "(" ++ show e ++ "*" ++ show f ++ ")"

eval :: Expr -> Int
eval (Con i)    =  i
eval (e :+: f)  =  eval e + eval f
eval (e :*: f)  =  eval e * eval f

expr :: Parser Expr
expr  =   always Con *** int
      +++ always add *** token '(' *** expr *** token '+' *** expr *** token ')'
      +++ always mul *** token '(' *** expr *** token '*' *** expr *** token ')'
  where
  add '(' e '+' f ')'  =  e :+: f
  mul '(' e '*' f ')'  =  e :*: f

